#pragma once

#include "IPCCopyData.h"

namespace tipbase
{
class IPCCopyDataMessageWindow : public CWindowImpl<IPCCopyDataMessageWindow, CWindow, CNullTraits>
{
public:
	IPCCopyDataMessageWindow( IPCCopyDataServer *server )
	{
		m_server = server;
	}

	~IPCCopyDataMessageWindow()
	{
		DestroyWindow();
	}

	// Optionally specify name of the new Windows class
	DECLARE_WND_CLASS(_T("IPCCopyDataMessageWindow")) 
	// If this macro is not specified in your
	// class, ATL will generate a class name

	BEGIN_MSG_MAP(IPCCopyDataMessageWindow)
		MESSAGE_HANDLER(WM_COPYDATA, OnCopyData)
	END_MSG_MAP()

	LRESULT OnCopyData(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		return m_server->Receive( IPCCopyDataServer::IPC_COPYDATA_COMMUNICATION_TYPE(wParam), reinterpret_cast<COPYDATASTRUCT *>(lParam) );
	}

private:
	IPCCopyDataServer* m_server;
};

};